unit BtnsList;

interface

uses
  Classes, StdCtrls;

type
  TButtonList = class(TObject)
  private
    FList: TList;
    function Get(Index: Integer): TButton;
    procedure Put(Index: Integer; Item: TButton);
    function GetCount: Integer;
  public
    constructor Create;
    destructor Destroy; override;
    function Add(Item: TButton): Integer;
    function Equals(List: TButtonList): Boolean;
    property Count: Integer
      read GetCount;
    property Items[Index: Integer]: TButton
      read Get write Put; default;
  end;

implementation

constructor TButtonList.Create;
begin
  inherited Create;
  FList := TList.Create;
end;

destructor TButtonList.Destroy;
begin
  FList.Free;
  inherited Destroy;
end;

function TButtonList.Get(Index: Integer): TButton;
begin
  Result := FList[Index];
end;

procedure TButtonList.Put(Index: Integer; Item: TButton);
begin
  FList[Index] := Item;
end;

function TButtonList.GetCount: Integer;
begin
  Result := FList.Count;
end;

function TButtonList.Add(Item: TButton): Integer;
begin
  Result := FList.Add(Item);
end;

function TButtonList.Equals(List: TButtonList): Boolean;
var
  I: Integer;
begin
  Result := False;
  if List.Count <> FList.Count then
    Exit;
  for I := 0 to List.Count - 1 do
    if List[I] <> FList[I] then
      Exit;
  Result := True;
end;

end.
